unit Oleobj;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ToCtrl, Menus;

type
  TOLEObjectForm = class(TForm)
    OleContainer: TOleContainer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    InsertObject1: TMenuItem;
    PasteSpecial1: TMenuItem;
    N2: TMenuItem;
    OLEObjectMenuItem: TMenuItem;
    Object2: TMenuItem;
    Deactivate1: TMenuItem;
    Window1: TMenuItem;
    Cascade1: TMenuItem;
    Tile1: TMenuItem;
    ArrangeIcons1: TMenuItem;
    SaveAsDialog: TSaveDialog;
    procedure New1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure ArrangeIcons1Click(Sender: TObject);
    procedure OleContainerStatusLineEvent(Sender: TObject; Msg: String);
    procedure InsertObject1Click(Sender: TObject);
    procedure Deactivate1Click(Sender: TObject);
    procedure PasteSpecial1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure InitializeOLEObject(Info: Pointer);
  public
    { Public declarations }
  end;

var
  OLEObjectForm: TOLEObjectForm;

implementation

uses OLEFrame;

{$R *.DFM}

procedure TOLEObjectForm.New1Click(Sender: TObject);
begin
  OLEFrameForm.New1Click(Sender)
end;

procedure TOLEObjectForm.Exit1Click(Sender: TObject);
begin
  OLEFrameForm.Exit1Click(Sender)
end;

procedure TOLEObjectForm.Cascade1Click(Sender: TObject);
begin
  OLEFrameForm.Cascade
end;

procedure TOLEObjectForm.Tile1Click(Sender: TObject);
begin
  OLEFrameForm.Tile
end;

procedure TOLEObjectForm.ArrangeIcons1Click(Sender: TObject);
begin
  OLEFrameForm.ArrangeIcons
end;

procedure TOLEObjectForm.OleContainerStatusLineEvent(Sender: TObject;
  Msg: String);
begin
  OLEFrameForm.StatusBarPanel.Caption := Msg
end;

procedure TOLEObjectForm.InitializeOLEObject(Info: Pointer);
begin
  OLEContainer.PInitInfo := Info;
  ReleaseOLEInitInfo(Info)
end;

procedure TOLEObjectForm.InsertObject1Click(Sender: TObject);
var
  Info: Pointer;
begin
  if InsertOLEObjectDlg(OLEFrameForm, 0, Info) then
    InitializeOLEObject(Info);
end;

procedure TOLEObjectForm.Deactivate1Click(Sender: TObject);
begin
  OLEContainer.Active := False
end;

procedure TOLEObjectForm.PasteSpecial1Click(Sender: TObject);
var
  ClipFmt: Word;
  DataHand: THandle;
  Info: Pointer;
begin
  if PasteSpecialEnabled(Self, OLEFrameForm.Fmts) then
    if PasteSpecialDlg(Self, OLEFrameForm.Fmts, 0,
      ClipFmt, DataHand, Info) then
      InitializeOLEObject(Info)
end;

procedure TOLEObjectForm.Edit1Click(Sender: TObject);
begin
  PasteSpecial1.Enabled := PasteSpecialEnabled(Self, OLEFrameForm.Fmts)
end;

procedure TOLEObjectForm.SaveAs1Click(Sender: TObject);
begin
  if SaveAsDialog.Execute then
    OLEContainer.SaveToFile(SaveAsDialog.Filename)
end;

procedure TOLEObjectForm.Open1Click(Sender: TObject);
begin
  OLEFrameForm.Open1Click(Sender)
end;

procedure TOLEObjectForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

end.
